
/***************************************************************************

                                 ChessV

                   COPYRIGHT (C) 2005 BY GREGORY STRONG

This file is part of ChessV.  ChessV is free software; you can redistribute
it and/or modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 2 of the License, 
or (at your option) any later version.

ChessV is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for 
more details; the file 'COPYING' contains the License text, but if for
some reason you need a copy, please write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************/


#include "StdAfx.h"
#include "../../ChessV.h"
#include "../../Resource.h"
#include "CapablancaGame.h"


static HWND hSubDialog;


LRESULT CALLBACK Capablanca_SelectDlgProc
	( HWND hWndDlg, 
	  UINT Msg, 
	  WPARAM wParam, 
	  LPARAM lParam )
{
	switch( Msg )
	{
	  case WM_INITDIALOG:
		{
			if( !strcmp( gameSelection, "Carrera's Chess" ) )
				::SendDlgItemMessage( hWndDlg, IDC_CARRERA, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
			else if( !strcmp( gameSelection, "Bird's Chess" ) )
				::SendDlgItemMessage( hWndDlg, IDC_BIRD, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
			else if( !strcmp( gameSelection, "Carrera's Chess" ) )
				::SendDlgItemMessage( hWndDlg, IDC_CARRERA, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
			else if( !strcmp( gameSelection, "Capablanca Chess, Aberg variant" ) )
				::SendDlgItemMessage( hWndDlg, IDC_ABERG, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
			else if( !strcmp( gameSelection, "Capablanca Chess, Paulowich variant" ) )
				::SendDlgItemMessage( hWndDlg, IDC_PAULOWICH, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
			else if( !strcmp( gameSelection, "Grotesque Chess" ) )
				::SendDlgItemMessage( hWndDlg, IDC_GROTESQUE, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
			else if( !strcmp( gameSelection, "Ladorean Chess" ) )
				::SendDlgItemMessage( hWndDlg, IDC_LADOREAN, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
			else if( !strcmp( gameSelection, "Univers Chess" ) )
				::SendDlgItemMessage( hWndDlg, IDC_UNIVERS, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
			else if( !strcmp( gameSelection, "Schoolbook Chess" ) )
				::SendDlgItemMessage( hWndDlg, IDC_SCHOOLBOOK, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
			else if( !strcmp( gameSelection, "Embassy Chess" ) )
				::SendDlgItemMessage( hWndDlg, IDC_EMBASSY, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
			else
				::SendDlgItemMessage( hWndDlg, IDC_CAPABLANCA, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
			
			return TRUE;
		}

	  case WM_COMMAND:
		switch(wParam)
		{
		  case IDOK:
			if( ::SendDlgItemMessage( hWndDlg, IDC_CAPABLANCA, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Capablanca Chess" );
			else if( ::SendDlgItemMessage( hWndDlg, IDC_BIRD, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Bird's Chess" );
			else if( ::SendDlgItemMessage( hWndDlg, IDC_CARRERA, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Carrera's Chess" );
			else if( ::SendDlgItemMessage( hWndDlg, IDC_ABERG, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Capablanca Chess, Aberg variant" );
			else if( ::SendDlgItemMessage( hWndDlg, IDC_PAULOWICH, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Capablanca Chess, Paulowich variant" );
			else if( ::SendDlgItemMessage( hWndDlg, IDC_GROTESQUE, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Grotesque Chess" );
			else if( ::SendDlgItemMessage( hWndDlg, IDC_LADOREAN, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Ladorean Chess" );
			else if( ::SendDlgItemMessage( hWndDlg, IDC_UNIVERS, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Univers Chess" );
			else if( ::SendDlgItemMessage( hWndDlg, IDC_SCHOOLBOOK, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Schoolbook Chess" );
			else if( ::SendDlgItemMessage( hWndDlg, IDC_EMBASSY, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Embassy Chess" );
			::EndDialog( hWndDlg, IDOK );
			return TRUE;
		}
		break;
	}

	return FALSE;
}
