
/***************************************************************************

                                 ChessV

                   COPYRIGHT (C) 2005 BY GREGORY STRONG

This file is part of ChessV.  ChessV is free software; you can redistribute
it and/or modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 2 of the License, 
or (at your option) any later version.

ChessV is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for 
more details; the file 'COPYING' contains the License text, but if for
some reason you need a copy, please write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************/


#include "StdAfx.h"
#include "../../ChessV.h"
#include "../../Resource.h"
#include "ChessGame.h"
#include "../../GameParameters.h"
#include "../../rand.h"


LRESULT CALLBACK Chess_SelectDlgProc
	( HWND hWndDlg, 
	  UINT Msg, 
	  WPARAM wParam, 
	  LPARAM lParam )
{
	int dlgRtn = 0;
	bool randomSetup = false;
	bool whiteAlmostChess = false;
	bool blackAlmostChess = false;

	switch( Msg )
	{
	  case WM_INITDIALOG:
		if( !strcmp( gameSelection, "Fischer Random Chess" ) )
			::SendDlgItemMessage( hWndDlg, IDC_FISCHER_RANDOM_RADIO, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
		else if( !strcmp( gameSelection, "Chess 480" ) )
			::SendDlgItemMessage( hWndDlg, IDC_CHESS480_RADIO, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
		else if( !strcmp( gameSelection, "Berolina Chess" ) )
			::SendDlgItemMessage( hWndDlg, IDC_BEROLINA_RADIO, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
		else if( !strcmp( gameSelection, "Switching Chess" ) )
			::SendDlgItemMessage( hWndDlg, IDC_SWITCHING_RADIO, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
		else if( !strcmp( gameSelection, "Polymorph Chess" ) )
			::SendDlgItemMessage( hWndDlg, IDC_POLYMORPH_RADIO, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
		else if( !strcmp( gameSelection, "Cylindrical Chess" ) )
			::SendDlgItemMessage( hWndDlg, IDC_CYLINDRICAL_RADIO, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
		else if( !strcmp( gameSelection, "Chess with Different Armies" ) )
			::SendDlgItemMessage( hWndDlg, IDC_CWDA_RADIO, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
		else if( !strcmp( gameSelection, "Chess with Augmented Knights" ) )
			::SendDlgItemMessage( hWndDlg, IDC_CWAK_RADIO, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
		else if( !strcmp( gameSelection, "Almost Chess" ) )
			::SendDlgItemMessage( hWndDlg, IDC_ALMOST_CHESS_RADIO, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
		else if( !strcmp( gameSelection, "Extinction Chess" ) )
			::SendDlgItemMessage( hWndDlg, IDC_EXTINCTION_RADIO, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
		else if( !strcmp( gameSelection, "Kinglet" ) )
			::SendDlgItemMessage( hWndDlg, IDC_KINGLET_RADIO, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
		else if( !strcmp( gameSelection, "Three Checks Chess" ) )
			::SendDlgItemMessage( hWndDlg, IDC_THREE_CHECKS_RADIO, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
		else if( !strcmp( gameSelection, "Ultima" ) )
			::SendDlgItemMessage( hWndDlg, IDC_ULTIMA_RADIO1, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
		else
			::SendDlgItemMessage( hWndDlg, IDC_CHESS_RADIO, BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) 0 );
		return TRUE;

	  case WM_COMMAND:
		switch(wParam)
		{
		  case IDOK:
			if( ::SendDlgItemMessage( hWndDlg, IDC_CHESS_RADIO, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Orthodox Chess" );
			else if( ::SendDlgItemMessage( hWndDlg, IDC_FISCHER_RANDOM_RADIO, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Fischer Random Chess" );
			else if( ::SendDlgItemMessage( hWndDlg, IDC_CHESS480_RADIO, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Chess 480" );
			else if( ::SendDlgItemMessage( hWndDlg, IDC_BEROLINA_RADIO, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Berolina Chess" );
			else if( ::SendDlgItemMessage( hWndDlg, IDC_SWITCHING_RADIO, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Switching Chess" );
			else if( ::SendDlgItemMessage( hWndDlg, IDC_POLYMORPH_RADIO, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Polymorph Chess" );
			else if( ::SendDlgItemMessage( hWndDlg, IDC_CYLINDRICAL_RADIO, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Cylindrical Chess" );
			else if( ::SendDlgItemMessage( hWndDlg, IDC_CWDA_RADIO, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Chess with Different Armies" );
			else if( ::SendDlgItemMessage( hWndDlg, IDC_CWAK_RADIO, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Chess with Augmented Knights" );
			else if( ::SendDlgItemMessage( hWndDlg, IDC_ALMOST_CHESS_RADIO, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Almost Chess" );
			else if( ::SendDlgItemMessage( hWndDlg, IDC_EXTINCTION_RADIO, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Extinction Chess" );
			else if( ::SendDlgItemMessage( hWndDlg, IDC_KINGLET_RADIO, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Kinglet" );
			else if( ::SendDlgItemMessage( hWndDlg, IDC_THREE_CHECKS_RADIO, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Three Checks Chess" );
			else if( ::SendDlgItemMessage( hWndDlg, IDC_ULTIMA_RADIO1, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
				strcpy( gameSelection, "Ultima" );
			else
				ASSERT(FALSE);

			randomSetup = (::SendDlgItemMessage( hWndDlg, IDC_FISCHER_RANDOM_RADIO, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED) ||
				          (::SendDlgItemMessage( hWndDlg, IDC_CHESS480_RADIO, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED);

			if( ::SendDlgItemMessage( hWndDlg, IDC_CWDA_RADIO, BM_GETCHECK, 0, (LPARAM) 0 ) == BST_CHECKED )
			{
				StoreParameter( "white-army", "Fabulous FIDEs" );
				StoreParameter( "black-army", "Fabulous FIDEs" );
			}

			//	determine specific variant selected
			if( randomSetup )
			{
				//	initialize the startup array randomly
				char *FEN = new char[44];
				strcpy( FEN, "rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR" );
				bool occupied[8];
				for( int x = 0; x < 8; x++ )
					occupied[x] = false;

				//	place first bishop
				switch( rand() % 4 )
				{
				  case 0:
					occupied[0] = true;
					FEN[0] = 'b';
					FEN[35] = 'B';
					break;
				  case 1:
					occupied[2] = true;
					FEN[2] = 'b';
					FEN[37] = 'B';
					break;
				  case 2:
					occupied[4] = true;
					FEN[4] = 'b';
					FEN[39] = 'B';
					break;
				  case 3:
					occupied[6] = true;
					FEN[6] = 'b';
					FEN[41] = 'B';
					break;
				}

				//	place second bishop
				switch( rand() % 4 )
				{
				  case 0:
					occupied[1] = true;
					FEN[1] = 'b';
					FEN[36] = 'B';
					break;
				  case 1:
					occupied[3] = true;
					FEN[3] = 'b';
					FEN[38] = 'B';
					break;
				  case 2:
					occupied[5] = true;
					FEN[5] = 'b';
					FEN[40] = 'B';
					break;
				  case 3:
					occupied[7] = true;
					FEN[7] = 'b';
					FEN[42] = 'B';
					break;
				}

				//	place the queen
				int skip = rand() % 6;
				int index = 0;
				while( occupied[index] )
					index++;
				while( skip > 0 )
				{
					index++;
					skip--;
					while( occupied[index] )
						index++;
				}
				occupied[index] = true;
				FEN[index] = 'q';
				FEN[index+35] = 'Q';

				//	place the first knight
				skip = rand() % 5;
				index = 0;
				while( occupied[index] )
					index++;
				while( skip > 0 )
				{
					index++;
					skip--;
					while( occupied[index] )
						index++;
				}
				occupied[index] = true;
				FEN[index] = 'n';
				FEN[index+35] = 'N';

				//	place the second knight
				skip = rand() % 4;
				index = 0;
				while( occupied[index] )
					index++;
				while( skip > 0 )
				{
					index++;
					skip--;
					while( occupied[index] )
						index++;
				}
				occupied[index] = true;
				FEN[index] = 'n';
				FEN[index+35] = 'N';

				//	place first rook
				index = 0;
				while( occupied[index] )
					index++;
				occupied[index] = true;
				FEN[index] = 'r';
				FEN[index+35] = 'R';

				//	place king
				index = 0;
				while( occupied[index] )
					index++;
				occupied[index] = true;
				FEN[index] = 'k';
				FEN[index+35] = 'K';

				//	place second rook
				index = 0;
				while( occupied[index] )
					index++;
				occupied[index] = true;
				FEN[index] = 'r';
				FEN[index+35] = 'R';

				StoreParameter( "array", FEN );
				delete[] FEN;
			}
			::EndDialog( hWndDlg, dlgRtn );
			return TRUE;
		}
		break;
	}

	return FALSE;
}
